SystemOrganization addCategory: #ConfigurationOfCDBFormat!

Object subclass: #ConfigurationOfCDBFormat
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCDBFormat'!

!ConfigurationOfCDBFormat class methodsFor: 'development support' stamp: 'kevingamelin 3/25/2016 16:26'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfCDBFormat class methodsFor: 'private' stamp: 'kevingamelin 3/25/2016 16:26'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfCDBFormat class methodsFor: 'private' stamp: 'kevingamelin 3/25/2016 16:26'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfCDBFormat class methodsFor: 'private' stamp: 'kevingamelin 3/25/2016 16:26'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfCDBFormat class methodsFor: 'metacello tool support' stamp: 'kevingamelin 3/25/2016 16:26'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCDBFormat class methodsFor: 'loading' stamp: 'kevingamelin 3/25/2016 16:26'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfCDBFormat class methodsFor: 'loading' stamp: 'kevingamelin 3/25/2016 16:26'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfCDBFormat class methodsFor: 'loading' stamp: 'kevingamelin 3/25/2016 16:26'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfCDBFormat class methodsFor: 'accessing' stamp: 'kevingamelin 3/25/2016 16:26'!
project

	^self new project! !

!ConfigurationOfCDBFormat class methodsFor: 'development support' stamp: 'kevingamelin 3/25/2016 16:26'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfCDBFormat methodsFor: 'baselines' stamp: 'kevingamelin 3/25/2016 16:28'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/TheProfessionals/CDBFormat/main/'.
		spec 
			package: #CDBFormat;
			package: #'CDBFormat-Test' with: [
				spec requires: #(#CDBFormat ). ]. ].
! !

!ConfigurationOfCDBFormat methodsFor: 'accessing' stamp: 'kevingamelin 3/25/2016 16:26'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfCDBFormat methodsFor: 'symbolic versions' stamp: 'kevingamelin 3/25/2016 16:30'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfCDBFormat methodsFor: 'accessing' stamp: 'kevingamelin 3/25/2016 16:26'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCDBFormat methodsFor: 'symbolic versions' stamp: 'kevingamelin 3/25/2016 16:31'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfCDBFormat methodsFor: 'versions' stamp: 'kevingamelin 3/25/2016 16:29'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.0'.
		spec author: 'kevingamelin'.
		spec timestamp: '3/25/2016 16:29'.
		spec 
			package: #CDBFormat with: 'CDBFormat-kevingamelin.2';
			package: #'CDBFormat-Test' with: #'CDBFormat-Test'. ].
! !

!ConfigurationOfCDBFormat methodsFor: 'versions' stamp: 'kevingamelin 3/25/2016 16:30'!
version11: spec
	<version: '1.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 1.1'.
		spec author: 'kevingamelin'.
		spec timestamp: '3/25/2016 16:30'.
		spec 
			package: #CDBFormat with: 'CDBFormat-kevingamelin.2';
			package: #'CDBFormat-Test' with: 'CDBFormat-Test-kevingamelin.1'. ].
! !
